unit BenTools;

interface

uses Classes;

type
   TOwnList = class(TList)
   public
      destructor  Destroy; override;
      procedure   ClearItems;
   end;

function  DirFileSize(filename: string): integer;
procedure RunWait(comline: string; CmdShow: integer);
procedure FindReplace(var s: string; Find, Rep: string);
procedure SwapStr(var s1, s2: string);
function  IsUpCase(const s: string): boolean;

implementation

uses SysUtils, Windows, Forms, WaitDlg;

function DirFileSize(filename: string): integer;
var
   Rec : TSearchRec;
begin
   Result := 0;
   try
      if FindFirst(filename, faAnyFile, Rec)=0 then
         Result := Rec.Size
      else
         raise Exception.Create('Unable to find file: '+filename);
   finally
      SysUtils.FindClose(Rec);
   end;
end;

procedure RunWait(comline: string; CmdShow: integer);
var
   StartInfo   : TStartupInfo;
   ProcInfo    : TProcessInformation;
   wf          : TWaitForm;
begin
   GetStartupInfo(StartInfo);
   if CmdShow = SW_SHOW then CmdShow := SW_SHOWNA;
   StartInfo.wShowWindow := CmdShow;
   if CreateProcess(nil, PChar(comline), nil, nil, false, 0, nil, nil, StartInfo, ProcInfo)=False then
      raise Exception.Create('Could not execute ' + comline);
   // Application.BringToFront;
   wf := TWaitForm.Create(Application.MainForm);
   wf.hProc := ProcInfo.hProcess;
   wf.ProcLab.Caption := comline;
   wf.BeginWait;
   wf.Free;
end;

procedure FindReplace(var s: string; Find, Rep: string);
var
   Done : boolean;
   p    : integer;
begin
   if Pos(Find, Rep)<>0 then raise Exception.Create('Find string is in Replace string!');
   repeat
      p := Pos(Find, s);
      Done := (p = 0);
      if not Done then begin
         s := Copy(s, 1, p-1) + Rep + Copy(s, p+Length(Find), Length(s));
      end;
   until Done;
end;

procedure SwapStr(var s1, s2: string);
var
   tmp : string;
begin
   tmp := s1;
   s1 := s2;
   s2 := tmp;
end;

function IsUpCase(const s: string): boolean;
var
   i : integer;
begin
   Result := True;
   for i := 1 to Length(s) do
      if s[i] <> UpCase(s[i]) then Result := False;
end;


// *** TOwnList ***

destructor TOwnList.Destroy;
begin
   ClearItems;
   inherited;
end;

procedure TOwnList.ClearItems;
var
   i : integer;
begin
   for i := 0 to Count-1 do
      TObject(Items[i]).Free;
end;


end.
