unit DataForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, DBCtrls, Mask, Db, Buttons, ExtCtrls;

type
  TGenericDataForm = class(TForm)
    DataSource1: TDataSource;
    BitBtn1: TBitBtn;
    DBNavigator1: TDBNavigator;
    BitBtn2: TBitBtn;
    procedure BitBtn1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure BitBtn2Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  GenericDataForm: TGenericDataForm;

implementation

uses DataMod;

{$R *.DFM}

procedure TGenericDataForm.BitBtn1Click(Sender: TObject);
begin
   if DataSource1.DataSet<>nil then
      if DataSource1.DataSet.State = dsEdit then
         DataSource1.DataSet.Post;
   Close;
end;

procedure TGenericDataForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var
   rc : integer;
begin
   if DataSource1.DataSet = nil then exit;
   
   if DataSource1.DataSet.State = dsEdit then begin
      rc := MessageDlg('Current record has been modified, save changes?',
         mtWarning, mbYesNoCancel, 0);
      if rc = mrCancel then begin
         CanClose := False;
         exit;
      end;
      if rc = mrYes then begin
         DataSource1.DataSet.Post;
      end;
      if rc = mrNo then begin
         DataSource1.DataSet.Cancel;
      end;
   end;
end;

procedure TGenericDataForm.BitBtn2Click(Sender: TObject);
begin
   if DataSource1.DataSet<>nil then
      if DataSource1.DataSet.State = dsEdit then
         DataSource1.DataSet.Cancel;
   Close;
end;

procedure TGenericDataForm.FormShow(Sender: TObject);
begin
   DataSource1.Enabled := True;
end;

procedure TGenericDataForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
   DataSource1.Enabled := False;
end;

procedure TGenericDataForm.FormCreate(Sender: TObject);
begin
   DataSource1.Enabled := False;
end;

end.
